"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const relay_query_service_1 = require("../services/relay-query.service");
function RelayedFieldResolver(to, through, options) {
    if (typeof through !== "function") {
        options = through;
        through = undefined;
    }
    return (target, propertyKey, descriptor) => {
        process.nextTick(() => {
            typedi_1.Container.get(relay_query_service_1.RelayedQueryService).makeMethodRelayedFieldResolver(target, propertyKey, descriptor, to, through, options);
        });
    };
}
exports.RelayedFieldResolver = RelayedFieldResolver;
//# sourceMappingURL=relayed-field-resolver.decorator.js.map