import { ClassValueThunk } from '../';
import { AdvancedOptions } from 'type-graphql/dist/decorators/types';
export declare function RelayedQuery<Model = any, Through = undefined>(to: ClassValueThunk<Model>): RelayedQueryFactory<Model, false>;
export declare function RelayedQuery<Model = any, Through = undefined>(to: ClassValueThunk<Model>, options: RelayedQueryOptions): RelayedQueryFactory<Model, false>;
export declare function RelayedQuery<Model = any, Through = any>(to: ClassValueThunk<Model>, through: ClassValueThunk<Through>): RelayedQueryFactory<Through, true>;
export declare function RelayedQuery<Model = any, Through = any>(to: ClassValueThunk<Model>, through: ClassValueThunk<Through>, options: RelayedQueryOptions): RelayedQueryFactory<Through, true>;
export declare type RelayedQueryTypedDescriptor<ActualModel = any, HasThrough extends boolean = false> = RelayedQueryGetterFunction<[number, ActualModel[], HasThrough extends true ? keyof ActualModel : void]> | RelayedQueryGetterFunction<[ActualModel[], number, HasThrough extends true ? keyof ActualModel : void]> | RelayedQueryGetterFunction<EntityWithCounts<ActualModel, HasThrough>>;
export declare type RelayedQueryGetterFunction<Y> = (...arg: any[]) => Promise<Y>;
export declare type RelayedQueryFactory<ActualModel = unknown, HasThrough extends boolean = false> = (target: Object, propertKey: string, descriptor: (HasThrough extends true ? TypedPropertyDescriptor<RelayedQueryGetterFunction<[ActualModel[], number, keyof ActualModel]>> : TypedPropertyDescriptor<RelayedQueryGetterFunction<[ActualModel[], number]>>) | (HasThrough extends true ? TypedPropertyDescriptor<RelayedQueryGetterFunction<[number, ActualModel[], keyof ActualModel]>> : TypedPropertyDescriptor<RelayedQueryGetterFunction<[number, ActualModel[]]>>) | (TypedPropertyDescriptor<RelayedQueryGetterFunction<EntityWithCounts<ActualModel, HasThrough>>>)) => void;
export declare type RelayedQueryOptions = LimitOffsetOptions & AdvancedOptions;
export interface EntityWithCounts<Model = any, HasThrough extends boolean = false> {
    count: number;
    rows: Model[];
    key?: HasThrough extends true ? keyof Model : undefined;
}
export interface LimitOffsetOptions {
    paginationInputType?: boolean | string;
    biDirectionalPageInfo?: boolean;
}
