"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const type_graphql_1 = require("type-graphql");
let SharedObjectFactory = class SharedObjectFactory {
    generatePageInfo(prefix, extending) {
        const pageInfoName = `${prefix}PageInfo`;
        const extend = extending ? extending() : Object;
        const PageInfo = class extends extend {
        };
        type_graphql_1.Field(() => Boolean)(PageInfo.prototype, 'hasNextPage');
        type_graphql_1.Field(() => Boolean)(PageInfo.prototype, 'hasPreviousPage');
        type_graphql_1.Field(() => String, { nullable: true })(PageInfo.prototype, 'startCursor');
        type_graphql_1.Field(() => String, { nullable: true })(PageInfo.prototype, 'endCursor');
        type_graphql_1.ObjectType(pageInfoName)(PageInfo);
        return PageInfo;
    }
    generateConnectionArgs(prefix) {
        if (!prefix)
            prefix = '';
        const argsName = `${prefix}ConnectionArgs`;
        const darkMagic = {
            [argsName]: class {
            },
        };
        type_graphql_1.Field(() => String, { nullable: true, description: 'Paginate before opaque cursor' })(darkMagic[argsName].prototype, 'before');
        type_graphql_1.Field(() => String, { nullable: true, description: 'Paginate after opaque cursor' })(darkMagic[argsName].prototype, 'after');
        type_graphql_1.Field(() => type_graphql_1.Int, { nullable: true, description: 'Paginate first' })(darkMagic[argsName].prototype, 'first');
        type_graphql_1.Field(() => type_graphql_1.Int, { nullable: true, description: 'Paginate last' })(darkMagic[argsName].prototype, 'last');
        type_graphql_1.ArgsType()(darkMagic[argsName]);
        type_graphql_1.InputType(argsName)(darkMagic[argsName]);
        return darkMagic[argsName];
    }
};
SharedObjectFactory = __decorate([
    typedi_1.Service()
], SharedObjectFactory);
exports.SharedObjectFactory = SharedObjectFactory;
//# sourceMappingURL=shared-object.factory.js.map