"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function connectionArgsFromResolverData(prototype, propertyKey, resolverData) {
    let args = resolverData.args;
    const paginationKey = Reflect.getMetadata('autorelay:connectionArgs:key', prototype, propertyKey);
    if (paginationKey) {
        args = args[paginationKey];
    }
    if (!args) {
        args = {};
    }
    return args;
}
exports.connectionArgsFromResolverData = connectionArgsFromResolverData;
//# sourceMappingURL=pagination-args-from-data.function.js.map