import { RelayedQueryTypedDescriptor } from './../decorators/relayed-query.decorator';
import { ResolverData } from "type-graphql";
import * as Relay from 'graphql-relay';
declare type UnPromisify<T> = T extends Promise<infer U> ? U : T;
export declare function RelayFromArrayCountFactory<TContext = {}, Model = any, HasThrough extends boolean = false>(prototype: any, propertyKey: string): (resolverData: ResolverData<TContext>, next: RelayedQueryTypedDescriptor<Model, HasThrough>) => Promise<Relay.Connection<Model> | import("..").AugmentedConnection<unknown, Model>>;
export declare function extractGetterFunctionReturn<Model = any, U extends boolean = false>(payload: UnPromisify<ReturnType<RelayedQueryTypedDescriptor<Model, U>>>): [number, Model[], (keyof Model)?];
export declare class WrongReturnType extends Error {
    constructor(message: string);
}
export {};
