import { RelayedQueryOptions, RelayedQueryTypedDescriptor, LimitOffsetOptions } from './../decorators/relayed-query.decorator';
import { ClassValueThunk } from "../types";
export declare class RelayedQueryService {
    makeMethodRelayedQuery<Model = any, Through = any>(target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<RelayedQueryTypedDescriptor<Through extends (undefined | null) ? Model : Through, Through extends (undefined | null) ? never : true>>, to: ClassValueThunk<Model>, through?: ClassValueThunk<Through>, options?: RelayedQueryOptions): void;
    makeMethodRelayedFieldResolver<Model = any, Through = any>(target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<RelayedQueryTypedDescriptor<Through extends (undefined | null) ? Model : Through, Through extends (undefined | null) ? never : true>>, to: ClassValueThunk<Model>, through?: ClassValueThunk<Through>, options?: RelayedQueryOptions): void;
    protected relayQueryOrFieldResolver<Model = any, Through = any>(target: Object, propertyKey: string, descriptor: TypedPropertyDescriptor<RelayedQueryTypedDescriptor<Through extends (undefined | null) ? Model : Through, Through extends (undefined | null) ? never : true>>, to: ClassValueThunk<Model>, through?: ClassValueThunk<Through>, options?: RelayedQueryOptions, isFieldResolver?: boolean): void;
    protected makeEdgeConnection<Model = any, Through = any>(to: ClassValueThunk<Model>, through?: ClassValueThunk<Through>): import("../graphql/dynamic-object.factory").ConnectionEdgeType<Model>;
    protected getQueryName(propertyKey: string, options?: RelayedQueryOptions): string;
    protected registerArgs(target: Object, propertyKey: string, options?: RelayedQueryOptions): void;
    protected getGlobalOptions(): LimitOffsetOptions;
}
