"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const limit_offset_paging_service_1 = require("./../services/limit-offset-paging.service");
const typedi_1 = require("typedi");
const type_graphql_1 = require("type-graphql");
const pagination_args_from_data_function_1 = require("../helpers/pagination-args-from-data.function");
function RelayLimitOffset() {
    return (prototype, propertyKey, parameterIndex) => {
        return type_graphql_1.createParamDecorator(exports.RelayLimitOffsetResolverFactory(prototype, String(propertyKey)))(prototype, propertyKey, parameterIndex);
    };
}
exports.RelayLimitOffset = RelayLimitOffset;
exports.RelayLimitOffsetResolverFactory = (prototype, propertyKey) => {
    return (resolverData) => {
        const args = pagination_args_from_data_function_1.connectionArgsFromResolverData(prototype, propertyKey, resolverData);
        return { ...typedi_1.Container.get(limit_offset_paging_service_1.LimitOffsetPagingService).getLimitOffset(args), _originalArgs: args };
    };
};
//# sourceMappingURL=limit-offset.decorator.js.map