import { AdvancedOptions } from 'type-graphql/dist/decorators/types';
import { MethodAndPropDecorator, ClassValueThunk } from '../types/types';
export declare function RelayedConnection(type: ClassValueThunk): MethodAndPropDecorator;
export declare function RelayedConnection<T = any>(type: ClassValueThunk<T>, options: RelayedConnectionOptions<T>): MethodAndPropDecorator;
export declare function RelayedConnection(type: ClassValueThunk, through: ClassValueThunk): MethodAndPropDecorator;
export declare function RelayedConnection<T = any>(type: ClassValueThunk, through: ClassValueThunk<T>, options: RelayedConnectionOptions<T>): MethodAndPropDecorator;
export interface RelayedConnectionOptions<Entity = any> {
    order?: {
        [P in keyof Entity]?: "ASC" | "DESC" | 1 | -1;
    };
    field?: RelayedConnectionFieldOptions;
}
export interface RelayedConnectionFieldOptions extends Omit<AdvancedOptions, 'defaultValue'> {
    nullable?: 'items';
}
